/**
 * This class file was automatically generated by jASN1 v1.7.1 (http://www.openmuc.org)
 */

package org.openmuc.josistack.internal.acse.asn1;

import java.io.IOException;
import java.io.InputStream;

import org.openmuc.jasn1.ber.BerByteArrayOutputStream;
import org.openmuc.jasn1.ber.BerLength;
import org.openmuc.jasn1.ber.BerTag;
import org.openmuc.jasn1.ber.types.BerAny;
import org.openmuc.jasn1.ber.types.BerBitString;
import org.openmuc.jasn1.ber.types.BerInteger;
import org.openmuc.jasn1.ber.types.BerObjectIdentifier;
import org.openmuc.jasn1.ber.types.BerOctetString;

public class Myexternal2 {

    public static class Encoding {

        public byte[] code = null;
        private BerAny singleASN1Type = null;
        private BerOctetString octetAligned = null;
        private BerBitString arbitrary = null;

        public Encoding() {
        }

        public Encoding(byte[] code) {
            this.code = code;
        }

        public void setSingleASN1Type(BerAny singleASN1Type) {
            this.singleASN1Type = singleASN1Type;
        }

        public BerAny getSingleASN1Type() {
            return singleASN1Type;
        }

        public void setOctetAligned(BerOctetString octetAligned) {
            this.octetAligned = octetAligned;
        }

        public BerOctetString getOctetAligned() {
            return octetAligned;
        }

        public void setArbitrary(BerBitString arbitrary) {
            this.arbitrary = arbitrary;
        }

        public BerBitString getArbitrary() {
            return arbitrary;
        }

        public int encode(BerByteArrayOutputStream os) throws IOException {

            if (code != null) {
                for (int i = code.length - 1; i >= 0; i--) {
                    os.write(code[i]);
                }
                return code.length;
            }

            int codeLength = 0;
            int sublength;

            if (arbitrary != null) {
                codeLength += arbitrary.encode(os, false);
                // write tag: CONTEXT_CLASS, PRIMITIVE, 2
                os.write(0x82);
                codeLength += 1;
                return codeLength;
            }

            if (octetAligned != null) {
                codeLength += octetAligned.encode(os, false);
                // write tag: CONTEXT_CLASS, PRIMITIVE, 1
                os.write(0x81);
                codeLength += 1;
                return codeLength;
            }

            if (singleASN1Type != null) {
                sublength = singleASN1Type.encode(os);
                codeLength += sublength;
                codeLength += BerLength.encodeLength(os, sublength);
                // write tag: CONTEXT_CLASS, CONSTRUCTED, 0
                os.write(0xA0);
                codeLength += 1;
                return codeLength;
            }

            throw new IOException("Error encoding BerChoice: No item in choice was selected.");
        }

        public int decode(InputStream is) throws IOException {
            return decode(is, null);
        }

        public int decode(InputStream is, BerTag berTag) throws IOException {

            int codeLength = 0;
            BerTag passedTag = berTag;

            if (berTag == null) {
                berTag = new BerTag();
                codeLength += berTag.decode(is);
            }

            if (berTag.equals(BerTag.CONTEXT_CLASS, BerTag.CONSTRUCTED, 0)) {
                BerLength length = new BerLength();
                codeLength += length.decode(is);
                singleASN1Type = new BerAny();
                codeLength += singleASN1Type.decode(is, length.val);
                return codeLength;
            }

            if (berTag.equals(BerTag.CONTEXT_CLASS, BerTag.PRIMITIVE, 1)) {
                octetAligned = new BerOctetString();
                codeLength += octetAligned.decode(is, false);
                return codeLength;
            }

            if (berTag.equals(BerTag.CONTEXT_CLASS, BerTag.PRIMITIVE, 2)) {
                arbitrary = new BerBitString();
                codeLength += arbitrary.decode(is, false);
                return codeLength;
            }

            if (passedTag != null) {
                return 0;
            }

            throw new IOException("Error decoding BerChoice: Tag matched to no item.");
        }

        public void encodeAndSave(int encodingSizeGuess) throws IOException {
            BerByteArrayOutputStream os = new BerByteArrayOutputStream(encodingSizeGuess);
            encode(os);
            code = os.getArray();
        }

        @Override
        public String toString() {
            if (singleASN1Type != null) {
                return "CHOICE{singleASN1Type: " + singleASN1Type + "}";
            }

            if (octetAligned != null) {
                return "CHOICE{octetAligned: " + octetAligned + "}";
            }

            if (arbitrary != null) {
                return "CHOICE{arbitrary: " + arbitrary + "}";
            }

            return "unknown";
        }

    }

    public static final BerTag tag = new BerTag(BerTag.UNIVERSAL_CLASS, BerTag.CONSTRUCTED, 8);

    public byte[] code = null;
    private BerObjectIdentifier directReference = null;
    private BerInteger indirectReference = null;
    private Encoding encoding = null;

    public Myexternal2() {
    }

    public Myexternal2(byte[] code) {
        this.code = code;
    }

    public void setDirectReference(BerObjectIdentifier directReference) {
        this.directReference = directReference;
    }

    public BerObjectIdentifier getDirectReference() {
        return directReference;
    }

    public void setIndirectReference(BerInteger indirectReference) {
        this.indirectReference = indirectReference;
    }

    public BerInteger getIndirectReference() {
        return indirectReference;
    }

    public void setEncoding(Encoding encoding) {
        this.encoding = encoding;
    }

    public Encoding getEncoding() {
        return encoding;
    }

    public int encode(BerByteArrayOutputStream os) throws IOException {
        return encode(os, true);
    }

    public int encode(BerByteArrayOutputStream os, boolean withTag) throws IOException {

        if (code != null) {
            for (int i = code.length - 1; i >= 0; i--) {
                os.write(code[i]);
            }
            if (withTag) {
                return tag.encode(os) + code.length;
            }
            return code.length;
        }

        int codeLength = 0;
        codeLength += encoding.encode(os);

        if (indirectReference != null) {
            codeLength += indirectReference.encode(os, true);
        }

        if (directReference != null) {
            codeLength += directReference.encode(os, true);
        }

        codeLength += BerLength.encodeLength(os, codeLength);

        if (withTag) {
            codeLength += tag.encode(os);
        }

        return codeLength;

    }

    public int decode(InputStream is) throws IOException {
        return decode(is, true);
    }

    public int decode(InputStream is, boolean withTag) throws IOException {
        int codeLength = 0;
        int subCodeLength = 0;
        BerTag berTag = new BerTag();

        if (withTag) {
            codeLength += tag.decodeAndCheck(is);
        }

        BerLength length = new BerLength();
        codeLength += length.decode(is);

        int totalLength = length.val;
        codeLength += totalLength;

        subCodeLength += berTag.decode(is);
        if (berTag.equals(BerObjectIdentifier.tag)) {
            directReference = new BerObjectIdentifier();
            subCodeLength += directReference.decode(is, false);
            subCodeLength += berTag.decode(is);
        }

        if (berTag.equals(BerInteger.tag)) {
            indirectReference = new BerInteger();
            subCodeLength += indirectReference.decode(is, false);
            subCodeLength += berTag.decode(is);
        }

        encoding = new Encoding();
        subCodeLength += encoding.decode(is, berTag);
        if (subCodeLength == totalLength) {
            return codeLength;
        }
        throw new IOException("Unexpected end of sequence, length tag: " + totalLength + ", actual sequence length: "
                + subCodeLength);

    }

    public void encodeAndSave(int encodingSizeGuess) throws IOException {
        BerByteArrayOutputStream os = new BerByteArrayOutputStream(encodingSizeGuess);
        encode(os, false);
        code = os.getArray();
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder("SEQUENCE{");
        boolean firstSelectedElement = true;
        if (directReference != null) {
            sb.append("directReference: ").append(directReference);
            firstSelectedElement = false;
        }

        if (indirectReference != null) {
            if (!firstSelectedElement) {
                sb.append(", ");
            }
            sb.append("indirectReference: ").append(indirectReference);
            firstSelectedElement = false;
        }

        if (!firstSelectedElement) {
            sb.append(", ");
        }
        sb.append("encoding: ").append(encoding);

        sb.append("}");
        return sb.toString();
    }

}
